Tabulka = {
	spocitatVysku: function(){
		var vyska = parseInt($(window).height() - $("nav").height() - $("header").height() - 10); // spočítáme výšku ovládacích prvků a borderů, abychom znali výšku tabulky
    	$("div").css("height", vyska+"px");
    	return vyska;
	},

	oznacitBunku: function(bunka){
		$(".vypnute").removeClass("vypnute"); // ovládací liště odebereme třídu vypnuté, protože už je co ovládat

		$(".oznacena").removeClass("oznacena");
		bunka.addClass("oznacena"); // označíme buňku

		$("header input").val(bunka.text()) .focus(); // vložíme text z buňky do editačního řádku a zacílíme ho

		$("#pismo-font option").filter(function(i, e) { return $(e).text() == bunka.data("pismo")}).prop("selected", true); // v selectu zvolit písmo vybrané buňky
		
		var regularni_vyraz = new RegExp(/^(#)((?:[A-Fa-f0-9]{3}){1,2})$/);  // otestujeme barvu pomocí regulárního výrazu
		if (regularni_vyraz.test(bunka.data("barva"))) // pokud je uživatelem vybraná barva vlastní
		 {
		  $("#pismo-barva option").filter(function(i, e) { return $(e).text() == "Vlastní"}).prop("selected", true);
		  $("#pismo-barva-vlastni").val(bunka.data("barva")) .css("background-color", bunka.data("barva"));
		 }
		  else
		   {
		   	$("#pismo-barva option").filter(function(i, e) { return $(e).data("barva") == bunka.data("barva")}).prop("selected", true);
		   }

		if (regularni_vyraz.test(bunka.data("barva-pozadi"))) // pokud je uživatelem vybraná barva vlastní
		 {
		  $("#pozadi-barva option").filter(function(i, e) { return $(e).text() == "Vlastní"}).prop("selected", true);
		  $("#pozadi-barva-vlastni").val(bunka.data("barva-pozadi")) .css("background-color", bunka.data("barva-pozadi"));
		 }
		  else
		   {
		   	$("#pozadi-barva option").filter(function(i, e) { return $(e).data("barva-pozadi") == bunka.data("barva-pozadi")}).prop("selected", true);
		   }

		return bunka;
	},

	Nastroje: {
		zmenitPismo: function(bunka, pismo){
			bunka.css("font-family", pismo) .data("pismo", pismo);
			return bunka;
		},

		velikostPisma: function(bunka, zvetsit){
			if (zvetsit)
			 {
			  bunka.css("font-size", parseInt(bunka.css("font-size"))+3);
			 }
			  else 
			   {
			   	bunka.css("font-size", parseInt(bunka.css("font-size"))-3);
			   }
			return bunka;
		},

		barvaPisma: function(bunka, barva){
			bunka.css("color", barva) .data("barva", barva);
			return bunka;
		},

		barvaPozadi: function(bunka, barva){
			bunka.css("background-color", barva) .data("barva-pozadi", barva);
			return bunka;
		},		

		vymazat: function(bunka){
			bunka.data("pismo", "Arial") .css({ // nastavit vybrané buňce defaultní hodnoty
				"font-family": "Arial",
				"font-size": "1em",
				"color": "black"
			});

			$("#pismo-font option").filter(function(i, e) { return $(e).text() == "Arial"}).prop("selected", true); // zvolit v selectu defaultní písmo
			$("#pismo-barva option").filter(function(i, e) { return $(e).data("barva") == "black"}).prop("selected", true);
			$("#pismo-barva").trigger("change"); // pokud je zvolená vlastní barva, bez eventu by se neskrylo její políčko
			$("#pozadi-barva option").filter(function(i, e) { return $(e).data("barva") == "white"}).prop("selected", true);
			$("#pozadi-barva").trigger("change"); // pokud je zvolená vlastní barva, bez eventu by se neskrylo její políčko			

			Tabulka.Nastroje.Rez.odebrat(bunka, "b"); // odebereme jednotlivé řezy písma
			Tabulka.Nastroje.Rez.odebrat(bunka, "i");
			Tabulka.Nastroje.Rez.odebrat(bunka, "u");

			var sloupec = bunka.data("sloupec");
			$("*[data-sloupec='"+sloupec+"']").attr("style", ""); //vymežeme výšku a šířku sloupci a řádku s buňkou
			var radek = bunka.data("radek");
			$("*[data-radek='"+radek+"']").attr("style", "");

			return bunka;
		},

		Rez: {
			pridat: function(bunka, rez){
				bunka.data(rez, "ano").wrapInner("<"+rez+"></"+rez+">");

				return bunka;
			},

			odebrat: function(bunka, rez){
				var obsah = bunka.find(rez).html(); // uložíme obsah řezového tagu do proměnné
				bunka.find(rez).remove(); // řezový tag odstraníme
				bunka.data(rez, "ne") .html(obsah); // vložíme obsah tagu to rodiče řezového tagu

				return bunka;
			}
		},

		Velikost: {
			sirka: function(bunka, zvetsit){
				var vyska = parseInt(bunka.css("max-height"));
				var sloupec = bunka.data("sloupec");
				if (zvetsit)
				 var sirka = parseInt(bunka.css("max-width"))+5;
				  else
				   var sirka = parseInt(bunka.css("max-width"))-5;
				$("*[data-sloupec='"+sloupec+"']").attr("style", "max-width: "+sirka+"px !important; width: "+sirka+"px !important"); // aplikujeme styly na  všechny elementy ve stejném sloupci

				return bunka;
			},

			vyska: function(bunka, zvetsit){
				var sirka = parseInt(bunka.css("max-width"));
				var radek = bunka.data("radek");
				if (zvetsit)
				 var vyska = parseInt(bunka.css("max-height"))+3;
				  else
				   var vyska = parseInt(bunka.css("max-height"))-3;
				$("*[data-radek='"+radek+"']").attr("style", "max-height: "+vyska+"px !important; height: "+vyska+"px !important"); // aplikujeme styly na  všechny elementy ve stejném řádku

				return bunka;
			}
		}
	}
};

$(document).ready(function() {
	$("nav").addClass("vypnute"); // přidáme ovládací liště třídu vypnuté, protože není co ovládat

	Tabulka.spocitatVysku();

	// Generování tabulky
	$("table").append("<tr><th>&nbsp;</th></tr>");
	for (var i = 1; i <= 26; i++) { // první řádek 
		var pismeno = String.fromCharCode(96 + i); // převod čísla na písmeno
		$("table tr:first-child").append("<th data-sloupec='"+i+"' data-radek='1'>"+pismeno+"</th>");
	};

	for (var i = 1; i <= 100; i++) { // řádky
		$("table").append("<tr data-sloupec='1' data-radek='"+i+"'><th>"+i+"</th></tr>");
		for (var n = 1; n <= 26; n++) { // sloupce
			$("table tr:nth-child("+parseInt(i+1)+")").append("<td data-sloupec='"+n+"' data-radek='"+i+"' data-pismo='Arial' data-barva='black' data-barva-pozadi='white' data-b='ne' data-i='ne' data-u='ne'></td>");
		};
	};


	$("td").click(function(){
		Tabulka.oznacitBunku($(this));  // označíme buňku při kliknutí na ni
	});

	$("header input").on("keyup", function(){
		$(".oznacena").html($("header input").val());
	});

    // Nástroje

    $("#tucne").click(function(){
    	if ($(".oznacena").data("b") == "ne")  // buňka není tučná
    	 {
    	  Tabulka.Nastroje.Rez.pridat($(".oznacena"), "b");
    	 }
    	  else
    	   {
 			Tabulka.Nastroje.Rez.odebrat($(".oznacena"), "b");
    	   }
    });

    $("#kurziva").click(function(){
    	if ($(".oznacena").data("i") == "ne")  // buňka není tučná
    	 {
    	  Tabulka.Nastroje.Rez.pridat($(".oznacena"), "i");
    	 }
    	  else
    	   {
 			Tabulka.Nastroje.Rez.odebrat($(".oznacena"), "i");
    	   }    	
    });

    $("#podtrzene").click(function(){
    	if ($(".oznacena").data("u") == "ne")  // buňka není tučná
    	 {
    	  Tabulka.Nastroje.Rez.pridat($(".oznacena"), "u");
    	 }
    	  else
    	   {
 			Tabulka.Nastroje.Rez.odebrat($(".oznacena"), "u");
    	   }    	
    });        

    $("#pismo-font").on("change", function(){  // styl fontu
    	Tabulka.Nastroje.zmenitPismo($(".oznacena"), $("#pismo-font option:selected").html());
    });

    $("#pismo-velikost-plus").click(function(){ // zvětšní písma
    	Tabulka.Nastroje.velikostPisma($(".oznacena"), true);
    });

    $("#pismo-velikost-minus").click(function(){ // zmenšení písma
    	Tabulka.Nastroje.velikostPisma($(".oznacena"), false);
    });    

    $("#pismo-barva").on("change", function(){ // změna barvy písma
    	if ($("#pismo-barva option:selected").html() != "Vlastní")  // uživatel zvolil barvu ze seznamu
    	 {
    	  $("#pismo-barva-vlastni").val("");
    	  $("#pismo-barva-vlastni").css("background-color", "white");	
    	  $("#pismo-barva-vlastni").hide();
    	  Tabulka.Nastroje.barvaPisma($(".oznacena"), $("#pismo-barva option:selected").data("barva"));
    	 }
    	  else 
    	   {  // uživatel vloží vlastní barvu
    	   	$("#pismo-barva-vlastni").show();
    	   	Tabulka.Nastroje.barvaPisma($(".oznacena"), "black");
    	   }
    });

    $("#pismo-barva-vlastni").on("keyup", function(){ // změna barvy z vlastního políčka
    	var barva = $("#pismo-barva-vlastni").val();
    	var regularni_vyraz = new RegExp(/^(#)((?:[A-Fa-f0-9]{3}){1,2})$/);  // otestujeme barvu pomocí regulárního výrazu
    	if (regularni_vyraz.test(barva)) // vložená barva je validní
    	 {
          Tabulka.Nastroje.barvaPisma($(".oznacena"), barva);
          $("#pismo-barva-vlastni").css("background-color", barva);
         }
          else
           Tabulka.Nastroje.barvaPisma($(".oznacena"), "black");
    });

    $("#pozadi-barva").on("change", function(){ // změna barvy pozadí
    	if ($("#pozadi-barva option:selected").html() != "Vlastní")  // uživatel zvolil barvu ze seznamu
    	 {
    	  $("#pozadi-barva-vlastni").val("");
    	  $("#pozadi-barva-vlastni").css("background-color", "white");	
    	  $("#pozadi-barva-vlastni").hide();
    	  Tabulka.Nastroje.barvaPozadi($(".oznacena"), $("#pozadi-barva option:selected").data("barva"));
    	 }
    	  else 
    	   {  // uživatel vloží vlastní barvu
    	   	$("#pozadi-barva-vlastni").show();
    	   	Tabulka.Nastroje.barvaPozadi($(".oznacena"), "white");
    	   }
    });

    $("#pozadi-barva-vlastni").on("keyup", function(){ // změna barvy pozadí z vlastního políčka
    	var barva = $("#pozadi-barva-vlastni").val();
    	var regularni_vyraz = new RegExp(/^(#)((?:[A-Fa-f0-9]{3}){1,2})$/);  // otestujeme barvu pomocí regulárního výrazu
    	if (regularni_vyraz.test(barva)) // vložená barva je validní
    	 {
          Tabulka.Nastroje.barvaPozadi($(".oznacena"), barva);
          $("#pozadi-barva-vlastni").css("background-color", barva);
         }
          else
           Tabulka.Nastroje.barvaPozadi($(".oznacena"), "white");
    });    

    // odebrání sloupce či řádku
    $("#odebrat-sloupec").click(function(){
		var sloupec = $(".oznacena").data("sloupec");
		$("*[data-sloupec='"+sloupec+"']").remove();

    });

    $("#odebrat-radek").click(function(){
 		var radek = $(".oznacena").data("radek");
		$("*[data-radek='"+radek+"']").remove();
   	
    });    

    // změna velikost buněk
    $("#velikost-sirka-zmensit").click(function(){
    	Tabulka.Nastroje.Velikost.sirka($(".oznacena"), false);
    });

    $("#velikost-sirka-zvetsit").click(function(){
    	Tabulka.Nastroje.Velikost.sirka($(".oznacena"), true);
    });

    $("#velikost-vyska-zmensit").click(function(){
    	Tabulka.Nastroje.Velikost.vyska($(".oznacena"), false);
    });

    $("#velikost-vyska-zvetsit").click(function(){
    	Tabulka.Nastroje.Velikost.vyska($(".oznacena"), true);
    });            

    $("#vymazat-formatovani").click(function(){ // vymazat všechno formátování
    	Tabulka.Nastroje.vymazat($(".oznacena"));
    });

    // konec nástrojů

	$("#napoveda").click(function(){ // otevřít nápovědu
		$("section").show();
		$("nav, header, div").css("opacity", ".25");
	});

	$("section .fa").click(function(){ // zavřít nápovědu
		$("section").hide();
		$("nav, header, div").css("opacity", "1");
	});
 });

$(window).on("resize", Tabulka.spocitatVysku); // přepočítat výšku tabulky